using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_RepositoryCategory
	/// </summary>
	public partial class T_RepositoryCategory
    {
        public T_RepositoryCategory()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_CategoryId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_RepositoryCategory");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_CategoryId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_RepositoryCategory model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_RepositoryCategory(");
            strSql.Append("F_CategoryName,F_ParentId,F_ParentPath,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy)");
            strSql.Append(" values (");
            strSql.Append("@F_CategoryName,@F_ParentId,@F_ParentPath,@F_Expand1,@F_Expand2,@F_CreateOn,@F_CreateBy)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ParentId", SqlDbType.Int,4),
                    new SqlParameter("@F_ParentPath", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Expand1", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Expand2", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CategoryName;
            parameters[1].Value = model.F_ParentId;
            parameters[2].Value = model.F_ParentPath;
            parameters[3].Value = model.F_Expand1;
            parameters[4].Value = model.F_Expand2;
            parameters[5].Value = model.F_CreateOn;
            parameters[6].Value = model.F_CreateBy;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_RepositoryCategory model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_RepositoryCategory set ");
            strSql.Append("F_CategoryName=@F_CategoryName,");
            strSql.Append("F_ParentId=@F_ParentId,");
            strSql.Append("F_ParentPath=@F_ParentPath,");
            strSql.Append("F_Expand1=@F_Expand1,");
            strSql.Append("F_Expand2=@F_Expand2,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ParentId", SqlDbType.Int,4),
                    new SqlParameter("@F_ParentPath", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Expand1", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Expand2", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CategoryName;
            parameters[1].Value = model.F_ParentId;
            parameters[2].Value = model.F_ParentPath;
            parameters[3].Value = model.F_Expand1;
            parameters[4].Value = model.F_Expand2;
            parameters[5].Value = model.F_CreateOn;
            parameters[6].Value = model.F_CreateBy;
            parameters[7].Value = model.F_CategoryId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_CategoryId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_RepositoryCategory ");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_CategoryId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_CategoryIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_RepositoryCategory ");
            strSql.Append(" where F_CategoryId in (" + F_CategoryIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_RepositoryCategory GetModel(int F_CategoryId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_CategoryId,F_CategoryName,F_ParentId,F_ParentPath,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy from T_RepositoryCategory ");
            strSql.Append(" where F_CategoryId=@F_CategoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_CategoryId;

            CallCenterApi.Model.T_RepositoryCategory model = new CallCenterApi.Model.T_RepositoryCategory();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_RepositoryCategory DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_RepositoryCategory model = new CallCenterApi.Model.T_RepositoryCategory();
            if (row != null)
            {
                if (row["F_CategoryId"] != null && row["F_CategoryId"].ToString() != "")
                {
                    model.F_CategoryId = int.Parse(row["F_CategoryId"].ToString());
                }
                if (row["F_CategoryName"] != null)
                {
                    model.F_CategoryName = row["F_CategoryName"].ToString();
                }
                if (row["F_ParentId"] != null && row["F_ParentId"].ToString() != "")
                {
                    model.F_ParentId = int.Parse(row["F_ParentId"].ToString());
                }
                if (row["F_ParentPath"] != null)
                {
                    model.F_ParentPath = row["F_ParentPath"].ToString();
                }
                if (row["F_Expand1"] != null)
                {
                    model.F_Expand1 = row["F_Expand1"].ToString();
                }
                if (row["F_Expand2"] != null)
                {
                    model.F_Expand2 = row["F_Expand2"].ToString();
                }
                if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                }
                if (row["F_CreateBy"] != null && row["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(row["F_CreateBy"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_CategoryId,F_CategoryName,F_ParentId,F_ParentPath,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy ");
            strSql.Append(" FROM T_RepositoryCategory ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_CategoryId,F_CategoryName,F_ParentId,F_ParentPath,F_Expand1,F_Expand2,F_CreateOn,F_CreateBy ");
            strSql.Append(" FROM T_RepositoryCategory ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_RepositoryCategory ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_CategoryId desc");
            }
            strSql.Append(")AS Row, T.*  from T_RepositoryCategory T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }
        
        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
